** GDOCS.PRG
** Login to Google Account and 
** upload documents to Google Docs
** Kevin Ragsdale - 20080421
** Version 0.0.1
#DEFINE CRLF	CHR(13) + CHR(10)

SET PROCEDURE TO wwutils.prg ADDI
SET PROCEDURE TO wwHTTP.prg ADDI

LOCAL loHTTP, loHTTPS

** wwHTTP object for 'normal' (Port 80) requests
loHTTP = CREATEOBJECT("wwHTTP")

** wwHTTP object for 'secure' (Port 443) requests
loHTTPS = CREATEOBJECT("wwHTTP")

** We need to login to the Google Account
** See http://code.google.com/apis/documents/developers_guide_protocol.html#AuthClientLogin

loHTTP.AddPostKey("accountType","GOOGLE")
loHTTP.AddpostKey("Email","PUT_YOUR_GOOGLE_ACCOUNT_USERNAME_HERE")
loHTTP.AddPostKey("Passwd","PUT_YOUR_GOOGLE_ACCOUNT_PASSWORD_HERE")
loHTTP.Addpostkey("service","writely")
loHTTP.Addpostkey("source","THIS_CAN_BE_ANYTHING YOU WANT")

** lcStr should contain an "Authenication Token" which 
** we'll need for future requests during this session.
lcStr = loHTTP.HTTPGet("https://www.google.com/accounts/ClientLogin")
?"Client Login Result from Google:" + CRLF + lcStr + CRLF + CRLF

** Grab just the authentication token
lcAuth = STREXTRACT(lcStr,"Auth=","/Auth",1,2)
?"Authentication Token: " + lcAuth + CRLF + CRLF

** Now that we're logged-in, add the token to our request header, 
** and include the name of the file as it should appear in Google Docs.
loHTTPS.cExtraHeaders = "Authorization: GoogleLogin auth=" + lcAuth + CRLF + ;
						"Slug: vfpalert-main.prg" + CRLF + ;
						"Content-Type: text/plain" 

** Clear the post keys					
loHTTPS.AddPostKey()

** Add a string to POST
loHTTPS.AddPostKey("",FILETOSTR("main.prg"))

** Make the POST
?loHTTPS.HTTPGet("http://docs.google.com/feeds/documents/private/full")

** Header Info from the response
?loHTTPS.cHTTPHeaders


** Now, create an error and post an Error Report
LOCAL loException As Exception
TRY
	CREATEOBJECT("SomekindofObject")	&& Cause the error
CATCH TO loException
ENDTRY

IF !ISNULL(loException)
	** Build the string to POST
	lcPost = "An Error Has Occurred at " + TTOC(DATETIME()) + ;
				CRLF + REPLICATE("-",80) + CRLF + CRLF + ;
				"Error #: " + TRANSFORM(loException.ErrorNo) + ;
				CRLF + ;
				"Details: " + ALLTRIM(loException.Message)
	
	** Clear the cExtraHeaders property
	loHTTPS.cExtraHeaders = ""

	lcString = loHTTPS.HTTPGet("http://docs.google.com/feeds/documents/private/full")

	** We'll give this one a "dynamic" title
	loHTTPS.cExtraHeaders = "Authorization: GoogleLogin auth=" + lcAuth + CRLF + ;
							"Slug: BugReport - " + DTOS(DATE()) + STRTRAN(TIME(),":","") + CRLF + ;
							"Content-Type: text/plain" 
	
	** Clear the PostKeys
	loHTTPS.AddPostKey()
	loHTTPS.AddPostKey("",lcPost)

	MESSAGEBOX(loHTTPS.HTTPGet("http://docs.google.com/feeds/documents/private/full"))
	MESSAGEBOX(loHTTPS.cHTTPHeaders)
ENDIF				

** Now, let's post a Word Document.
** Clear the cExtraHeaders property
loHTTPS.cExtraHeaders = ""
	
lcString = loHTTPS.HTTPGet("http://docs.google.com/feeds/documents/private/full")

** We'll give this one a "dynamic" title, and note the Content Type
loHTTPS.cExtraHeaders = "Authorization: GoogleLogin auth=" + lcAuth + CRLF + ;
						"Slug: My Word Document" + CRLF + ;
						"Content-Type: application/msword" 
	
** Clear the PostKeys
loHTTPS.AddPostKey()
loHTTPS.AddPostKey("",FILETOSTR("gDocs.doc"))

loHTTPS.HTTPGet("http://docs.google.com/feeds/documents/private/full")
?loHTTPS.cHTTPHeaders


** Now, let's get a list of documents from Google, and save it as 
** an XML file. This time, we'll just send the Authentication Token, 
** and clear the Post Keys.
loHTTPS.cExtraHeaders = "Authorization: GoogleLogin auth=" + lcAuth
loHTTPS.AddPostKey()

STRTOFILE(loHTTPS.HTTPGet("http://docs.google.com/feeds/documents/private/full"),"gDocs.xml")

loHTTP = NULL
loHTTPS = NULL

RETURN